# SPOD-MANAGER

## Requirements
* Linux (tested on Kernel  3.19.0-25-generic)
* Apache Web Server (local installation)
* MySql Server (local and remote installation)
* Git shell client
* ROUTE-TO_PA source code account
* Root access on local machine

## Download 

    wget http://service.routetopa.eu:7480/carspa/spod-manager/raw/master/spod-manager.sh
    chmod +x spod-manager.sh

## Actions help

    sudo ./spod-manager.sh --help
    spod-manager.sh is manager tool for SPOD application of ROUTE-TO-PA European project all rights are reserved. 2015
    list of arguments:
    -h, --help                          show commands help.
    -a, --action=ACTION                 specify an action install, uninstall, update, backup and restore.
    -m, --mysql-username=username       specify the username of mysql (*).
    -n, --mysql-password=password       specify the password of mysql server (*).
    -o, --mysql-address=address         specify the address of mysql server (deafult is localhost).
    -p, --spod-git-username=user        specify the user name of SPOD git server (*).
    -q, --spod-git-email=email          specify the email of SPOD git server (*).
    -r, --spod-git-password=password    specify the passoword of SPOD git server (*).
    -s, --spod-git-address=address:port specify the SPOD git server (deafult is service.routetopa.eu:7480).
    -w, --spod-hostname=hostname        specify the SPOD host name (example http://spod.routetopa.eu/).
    -e, --spod-www-backup=www-folder    specify the SPOD www folder path.
    -d, --spod-database-version=db      specify the SPOD db git path located in db_dump of SPOD git core (example in backup action: oxwall_v.0.1_antares.sql, deafults is really simple SPOD and Oxwall installationi; in restore action use a local db dump).
    -b, --backup-dir=DIR                specify the directory where store the spod backup (default is current directory).
    * the arguments is required.

## Actions examples

### INSTALLATION SPOD
    
    sudo ./spod-manager.sh -a install -m root -n mysqlpass -p usergit -q emailusergit -r passgit -w http://spod.routetopa.eu/ -d oxwall_v.0.1_antares.sql

### UNINSTALLATION SPOD
    
    sudo ./spod-manager.sh -a uninstall -m root -n mysqlpass

### BACKUP SPOD

    sudo ./spod-manager.sh -a backup -m root -n mysqlpass -b ./test

### UPDATE SPOD

    sudo ./spod-manager.sh -a update -p usergit -q emailuserigit -r passgit -w http://spod.routetopa.eu/
    
### RESTORE DB SPOD
    
    sudo ./spod-manager.sh -a restoredb -m root -n mysqlpass -d /home/user/spod-manager/oxwall_version_dump.sql
    
### RESTORE ALL SPOD
    
    sudo ./spod-manager.sh -a restoreall -m root -n mysqlpass -e /var/www -d /home/user/spod-manager/oxwall_version_dump.sql